searchData={"items":[{"type":"module","title":"DistributedSupervisor","doc":"`DistributedSupervisor` is exactly what its name says. It’s a `DynamicSupervisor` working\n  transparently in a distributed environment.","ref":"DistributedSupervisor.html"},{"type":"module","title":"Example - DistributedSupervisor","doc":"```elixir\niex|🌢|n1@am|1> DistributedSupervisor.start_link(name: DS, cache_children?: true)\n{:ok, #PID<0.307.0>}\niex|🌢|n1@am|2> DistributedSupervisor.start_child(DS, {MyGenServer, name: MGS})\n{:ok, #PID<0.311.0>, MGS}\niex|🌢|n1@am|3> DistributedSupervisor.children(DS)\n%{MGS => {#PID<0.311.0>, %{id: …}}}\n```","ref":"DistributedSupervisor.html#module-example"},{"type":"function","title":"DistributedSupervisor.call/4","doc":"A syntactic sugar for `GenServer.call/3` allowing to call a dynamically supervised\n  `GenServer` by registry name and key.","ref":"DistributedSupervisor.html#call/4"},{"type":"function","title":"DistributedSupervisor.cast/3","doc":"A syntactic sugar for `GenServer.cast/2` allowing to call a dynamically supervised\n  `GenServer` by registry name and key.","ref":"DistributedSupervisor.html#cast/3"},{"type":"function","title":"DistributedSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DistributedSupervisor.html#child_spec/1"},{"type":"function","title":"DistributedSupervisor.children/1","doc":"Returns a map with registered names as keys and pids as values for the instance of the\n  registry with a name `name`.","ref":"DistributedSupervisor.html#children/1"},{"type":"type","title":"DistributedSupervisor.id/0","doc":"The id of the child process within the instance of the distributed supervisor. \nMight be whatever. If not passed explicitly to the `DistributedSupervisor.start_child/2`,\n  the reference will be created automatically and returned as a third element\n  of the `{:ok, pid, child_name}` success tuple.","ref":"DistributedSupervisor.html#t:id/0"},{"type":"function","title":"DistributedSupervisor.local_children/1","doc":"Returns a list of pids of local children","ref":"DistributedSupervisor.html#local_children/1"},{"type":"function","title":"DistributedSupervisor.mine?/2","doc":"Returns `true` if called from a node assigned to this key, `false` otherwise","ref":"DistributedSupervisor.html#mine?/2"},{"type":"type","title":"DistributedSupervisor.name/0","doc":"The name of the instance of this distributed supervisor. \nUnlike `t:GenServer.name/0`, it must be an atom.","ref":"DistributedSupervisor.html#t:name/0"},{"type":"function","title":"DistributedSupervisor.node_for/2","doc":"Returns the node for the key given according to a `HashRing`","ref":"DistributedSupervisor.html#node_for/2"},{"type":"function","title":"DistributedSupervisor.nodes/1","doc":"Returns the list of nodes operated by a registered ring","ref":"DistributedSupervisor.html#nodes/1"},{"type":"function","title":"DistributedSupervisor.send/3","doc":"A syntactic sugar for `Kernel.send/2` allowing to send a message to\n   a dynamically supervised `GenServer` identified by registry name and key.","ref":"DistributedSupervisor.html#send/3"},{"type":"function","title":"DistributedSupervisor.start_child/3","doc":"Dynamically adds a child specification to supervisor and starts that child.\n\n`child_spec` should be a valid child specification as detailed in the “Child specification”\n  section of the documentation for `Supervisor` expressed as a `t:Supervisor.child_spec/0`\n  or as a tuple `{module, start_link_arg}`.\n\nThe child process will be started as defined in the child specification. The core\n  difference from `DynamicSupervisor` is that the process must be named.\nThe name might be any term, passed through `name:` option in a call to this function.\nIf `name` option is not passed, it gets assigned randomly and returned in the third\n  element of the tuple from `start_child/2`.\n\nThis function accepts an optional third argument `node`. If it’s passed, the process\n  will be started on that node; the node will be chosed according to a keyring otherwise.\n\n_See:_ `DynamicSupervisor.start_child/2`","ref":"DistributedSupervisor.html#start_child/3"},{"type":"function","title":"DistributedSupervisor.start_link/1","doc":"Starts the `DistributedSupervisor`.","ref":"DistributedSupervisor.html#start_link/1"},{"type":"function","title":"Options to `DistributedSupervisor.start_link/1` - DistributedSupervisor.start_link/1","doc":"* `:name` (`t:atom/0`) - Required. The unique `ID` of this _DistributedSupervisor_, that will be used to address it, similar to `DynamicSupervisor.name()`\n\n* `:cache_children?` (`t:boolean/0`) - If `true`, `Registry` will cache children as a map of `%{name => %{pid() => initial_params}}`, setting this to `false` would block the functionañity of restarting a process on another node when any node goes down The default value is `true`.\n\n* `:nodes` (list of `t:atom/0`) - The hardcoded list of nodes to spread children across, if not passed, all connected nodes will be used The default value is `[]`.\n\n* `:monitor_nodes` (`t:atom/0`) - If not false, the `HashRing` will be automatically updated when nodes are changed in the cluster The default value is `false`.\n\n* `:listeners` - The implementation of `DistributedSupervisor.Listener` to receive notifications upon process restarts The default value is `[]`.","ref":"DistributedSupervisor.html#start_link/1-options-to-distributedsupervisor-start_link-1"},{"type":"function","title":"DistributedSupervisor.terminate_child/2","doc":"Terminates the given child identified by pid.\n\nIf successful, this function returns `:ok`.\nIf there is no process with the given PID, this function returns `{:error, :not_found}`.\n\n_See:_ `DynamicSupervisor.terminate_child/2`","ref":"DistributedSupervisor.html#terminate_child/2"},{"type":"function","title":"DistributedSupervisor.via_name/2","doc":"Returns a fully qualified name to use with a standard library functions,\n  accepting `{:via, Registry, key}` as a `GenServer` name.","ref":"DistributedSupervisor.html#via_name/2"},{"type":"function","title":"DistributedSupervisor.whereis/2","doc":"Returns a `t:pid()` for the instance of the registry with a name `name` by key.\n\n_See:_ `DistributedSupervisor.children/1`","ref":"DistributedSupervisor.html#whereis/2"},{"type":"behaviour","title":"DistributedSupervisor.Listener","doc":"The implementation of this behaviour might be passed\n to `DistributedSupervisor.start_link/1` to receive\n  notifications about processes state.","ref":"DistributedSupervisor.Listener.html"},{"type":"callback","title":"DistributedSupervisor.Listener.on_node_down/3","doc":"","ref":"DistributedSupervisor.Listener.html#c:on_node_down/3"},{"type":"callback","title":"DistributedSupervisor.Listener.on_node_terminate/4","doc":"","ref":"DistributedSupervisor.Listener.html#c:on_node_terminate/4"},{"type":"callback","title":"DistributedSupervisor.Listener.on_node_up/3","doc":"","ref":"DistributedSupervisor.Listener.html#c:on_node_up/3"},{"type":"callback","title":"DistributedSupervisor.Listener.on_process_start/3","doc":"","ref":"DistributedSupervisor.Listener.html#c:on_process_start/3"},{"type":"callback","title":"DistributedSupervisor.Listener.on_process_stop/3","doc":"","ref":"DistributedSupervisor.Listener.html#c:on_process_stop/3"},{"type":"extras","title":"DistributedSupervisor","doc":"# DistributedSupervisor","ref":"readme.html"},{"type":"extras","title":"Purpose - DistributedSupervisor","doc":"`DistributedSupervisor` is exactly what its name says. It’s a `DynamicSupervisor` working\ntransparently in a distributed environment.","ref":"readme.html#purpose"},{"type":"extras","title":"Example - DistributedSupervisor","doc":"```elixir\niex|🌢|n1@am|1> DistributedSupervisor.start_link(name: DS)\n{:ok, #PID<0.307.0>}\niex|🌢|n1@am|2> DistributedSupervisor.start_child(DS, {MyGenServer, name: MGS})\n{:ok, #PID<0.311.0>, MGS}\niex|🌢|n1@am|3> DistributedSupervisor.children(DS)\n%{MGS => #PID<0.311.0>}\n```","ref":"readme.html#example"},{"type":"extras","title":"Installation - DistributedSupervisor","doc":"```elixir\ndef deps do\n  [\n    {:distributed_supervisor, \"~> 0.1\"}\n  ]\nend\n```\n\n## [Documentation](https://hexdocs.pm/distributed_supervisor).","ref":"readme.html#installation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}